"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: ()=>_default
});
const _utilJs = require("./util.js");
/** @type {import("../").SyntaxDefinition} */ const R = {
    comment: [
        (0, _utilJs.join)('|', /(\/\*)[^]*?(\*\/)/, /(\s?(\/\/)[\S\s]*?(?=[\n\r]))/, /(\/\*)[^]*/),
        {
            _: [
                /@\w*\s?[\w:/.-]+/,
                {
                    comment: /(?<=@returns)\s\w+/,
                    declare: /@\w+/
                }
            ],
            comment: /.+?/
        }
    ],
    keyword: (0, _utilJs.join)('', /\b/, (0, _utilJs.split)(`
      break do instanceof typeof case else new try catch finally
      return continue for of switch while with debugger default
      if throw delete in as from export import async await void
      extends implements private public package protected static
      declare yield
    `), /\b(?![:()])/),
    declare: (0, _utilJs.join)('', /\b(?![:])/, (0, _utilJs.split)(`
      class function constructor prototype
      const get set var let interface type
      enum string boolean number any unknown never
      Object String Number RegExp Buffer Math
      Set Map
    `), /\b(?![:])/),
    function: (0, _utilJs.join)('|', /[$#\w]+(?=(\s=)?\s*[<(`])/, /(?<=(class|interface)\s+)\w+(?=(<\w>)?\s*((extends|implements)\s*[\w<>]+\s*(implements\s*\w+\s*)?)?\s*\{)/, /(?<=extends\s+)\w+/, /(?<=implements\s+)\w+/),
    arrow: /=>/,
    builtin: (0, _utilJs.split)(`true false null undefined NaN Infinity`),
    imports: [
        /(?<=import|export).*[\w{}*]+(?=\sfrom\s)/,
        {
            keyword: /\sas\s/,
            builtin: /\*/ // highlights the asterisk import
        }
    ],
    special: (0, _utilJs.split)('this super'),
    regexp: [
        /\/((?:\\\/)|[^/\n\s])+?\/[gimsuy]*/,
        {
            builtin: /\\.*?\]|\\[^]/,
            operator: /[\^+*?]/,
            string: /.+?/
        }
    ],
    string: (0, _utilJs.join)('|', /('(?:(?:\\\n|\\'|[^'\n]))*'?)/, /("(?:(?:\\\n|\\"|[^"\n]))+"?)/),
    arguments: null,
    property: /\w+(?=:)/,
    punctuation: `[ ] ( ) { } ; ,`,
    number: (0, _utilJs.join)('', (0, _utilJs.join)('', /(?=\.\d|\d)/, /(?:\d+)?/, /(?:\.?\d*)/), /(?:[eE]([+-]?\d+))?/),
    operator: (0, _utilJs.modify)('{1}', (0, _utilJs.split)(`
      : + - ~ !
      ** ?? ?. >> << >>> < > <= >= == != === !==
      && || *= /= %= += -= <<= >>= >>>= &= ^= |= **=
      = ? ... * / % & ^ | ++ --
    `))
};
R.arguments = [
    (0, _utilJs.join)('|', /\w+\s+(?==>)/, (0, _utilJs.join)('', /(?<=(function\s+\w+|async)\s*\([^\s]*)/, /(?<=\([^)]*)/, /[^)]*/, /(?=.*(=>|{))/), (0, _utilJs.join)('', /(?<!(if|for|while|switch).*)/, /(?<=\()[^)]*(?=\).+{)/), (0, _utilJs.join)('', /(?<!(if|for|while|switch).*)/, // /(?<=([=:,]|=>)\s*\([^\s]*)/,
    /(?<=\([^)]*)/, /[^)]*/, /(?=.*(=>|{))/)),
    {
        _: [
            /(?:[:=|<]\s?)\w+/,
            {
                ...R,
                arguments: null
            }
        ],
        ...R,
        arguments: /[$\w]+/
    }
];
R.template = [
    /(`(?:(?:\\`|[^`]))*`?)/,
    {
        template: [
            /\$\{[^]*?\}/,
            {
                ...R,
                operator: (0, _utilJs.join)('|', R.operator, /\$\{|}/)
            }
        ],
        string: /.+?/
    }
];
const _default = R;

//# sourceMappingURL=js.js.map