"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, /** @type {import("../").SyntaxDefinition} */ "default", {
    enumerable: true,
    get: ()=>_default
});
const _utilJs = require("./util.js");
const ids = /[a-zA-Z_$][a-zA-Z0-9_$]*/;
const num = /inf|nan|\d[\d_]*(\.((e[+-]?)?[\d]+)+[kBb]*|(e[+-]?[\d]+)?[kBb]*)/;
const ops = /\+\+|--|\+=|-=|\*=|\/=|%=|<<=|>>=|&=|\^=|\|=|&&|!&|\|\||!=|==|>=|<=|>>|<<|\.\.|[{}\\"'`,\-~+*/%=<>?!:;.|&^@]{1}/;
const _default = {
    declare: [
        (0, _utilJs.join)('', (0, _utilJs.modify)('+', (0, _utilJs.join)('|', ids, num, ops, /[[\](),.=\s+]/)), /\)\s+=/),
        {
            arguments: [
                /(?<=\().*?(?=\))/,
                {
                    declare: num,
                    string: /[[\]]/,
                    arguments: /\w+/,
                    operator: ops
                }
            ],
            arrow: /=$/,
            declare: ids,
            operator: ops,
            punctuation: /[[\]()]/
        }
    ],
    property: (0, _utilJs.join)('', ids, /(?=\()/),
    number: num,
    string: /[[\]()]/,
    punctuation: /[[\](),]/,
    operator: ops
};

//# sourceMappingURL=mono.js.map