var __decorate = this && this.__decorate || function(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import $ from 'sigl';
import { escape } from 'html-escaper';
import { compile, syntax as syntaxHighlight } from './syntax';
export const languages = {};
const compiled = new Map();
const style = /*css*/ `
:host {
  contain: layout style paint;
  display: block;
}
* {
  contain: layout style paint;
  text-rendering: optimizeSpeed;
  color: var(--color);
}
*::selection {
  background: var(--selection) !important;
}
pre,
code {
  margin: 0;
  text-rendering: optimizeSpeed;
  font-family: inherit;
}
slot {
  display: none;
}`;
const keyStyle = (x)=>/*css*/ `
.${x} {
  color: var(--${x});
  font-style: var(--${x}-style);
  font-weight: var(--${x}-weight);
}`;
export let CodeSyntaxElement = class CodeSyntaxElement extends HTMLElement {
    root = $.shadow(this, /*html*/ `<style>${style}</style><slot></slot><pre><code></code></pre>`);
    language = $.String;
    theme = $.String;
    syntax;
    codeRef;
    codeHTML;
    codeRawText;
    highlight;
    onTextContent;
    mounted($) {
        $.codeRef = $.query('code');
        // prevents unstyled content from showing until attributes
        // have arrived and the actual syntax has compiled
        setTimeout(()=>{
            if ($.highlight == null) $.highlight = escape;
        }, 100);
        $.effect(({ language  })=>{
            if (language in languages) $.syntax = languages[language];
        });
        $.effect(({ root  })=>$.onTextChange(root, (text)=>{
                $.codeRawText = text;
            }));
        $.effect(async ({ root , syntax  })=>{
            let { style , regexp  } = compiled.get(syntax) ?? {};
            if (!regexp || !style) {
                regexp = await compile(syntax);
                style = new CSSStyleSheet();
                await style.replace([
                    ...regexp.keys
                ].map(keyStyle).join(''));
                compiled.set(syntax, {
                    style,
                    regexp
                });
            }
            root.adoptedStyleSheets = [
                style
            ];
            $.highlight = (s)=>syntaxHighlight(regexp, s);
        });
        $.codeHTML = $.reduce(({ codeRawText , highlight  })=>highlight(codeRawText));
        $.effect(({ codeRef , codeHTML  })=>{
            codeRef.innerHTML = codeHTML;
        });
    }
};
__decorate([
    $.attr()
], CodeSyntaxElement.prototype, "language", void 0);
__decorate([
    $.attr()
], CodeSyntaxElement.prototype, "theme", void 0);
CodeSyntaxElement = __decorate([
    $.element()
], CodeSyntaxElement);

//# sourceMappingURL=element.js.map