import css from './css.js';
import js from './js.js';
/** @type {import("../").SyntaxDefinition} */ export default {
    script: [
        /(?<=<script[^>]*?>)[^]*?(?=<\/script>)/,
        js
    ],
    style: [
        /(?<=<style[^>]*?>)[^]*?(?=<\/style>)/,
        css
    ],
    comment: /<!--[^]*?-->|<!--[^]*/,
    tag: [
        /(?<=<\/?)([^<]*?(".+?")[^<]*|([^>]*))(?=>)/,
        {
            _: [
                /^[/!]?[\w-]+/,
                {
                    tag: /[\w-]+/ // this small bypass so it doesn't highlight the slashes /
                }
            ],
            string: /".*?"/,
            attribute: /[\w-]+/
        }, 
    ]
};

//# sourceMappingURL=html.js.map