import $ from 'sigl';
import { RegExpMapped, SyntaxDefinition, SyntaxOrImport } from './syntax';
export type { RegExpMapped, SyntaxDefinition, SyntaxOrImport };
export declare const languages: Record<string, SyntaxOrImport>;
export interface CodeSyntaxElement extends $.Element<CodeSyntaxElement> {
}
export declare class CodeSyntaxElement extends HTMLElement {
    root: ShadowRoot;
    language: string | undefined;
    theme: string | undefined;
    syntax?: SyntaxOrImport;
    codeRef?: HTMLElement;
    codeHTML?: string;
    codeRawText?: string;
    highlight?: (s: string) => string;
    onTextContent?: (textContent: string) => void;
    mounted($: this['$']): void;
}
